using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Configuration;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using System.Xml;

using System.Text.RegularExpressions;

namespace tfcSocket

{
    public partial class frmSocket : Form
    {
        private delegate void addTextDelegate(string s);
        addTextDelegate addText;
        cTFCmanager pManager;

        //-----------------------------------------------------------------------------------------------------

        public frmSocket()
        {
            InitializeComponent();

            string address = ConfigurationManager.AppSettings["RemoteObjectServer"].ToString();
            pManager = (cTFCmanager)Activator.GetObject(typeof(cTFCmanager), address);
            addText = new addTextDelegate(addTextLog);

            btnConectar.Enabled = true;
            btnDesconectar.Enabled = false;
        }
        //-----------------------------------------------------------------------------------------------------

        private void btnConectar_Click(object sender, EventArgs e)
        {
            if (edtIP.Text == "")
                return;

            if (edtPort.Text == "")
                return;

            pManager.connectSF(edtIP.Text, Convert.ToInt32(edtPort.Text));

            btnConectar.Enabled = false;
            btnDesconectar.Enabled = true;
        }
        //-----------------------------------------------------------------------------------------------------

        private void btnDesconectar_Click(object sender, EventArgs e)
        {
            pManager.disconnectSF();
            
            btnConectar.Enabled = true;
            btnDesconectar.Enabled = false;

        }
        //-----------------------------------------------------------------------------------------------------

        private void addTextLog(string log)
        {
            lbxLog.BeginUpdate();
            if (lbxLog.Items.Count > 200)
                for (int i = 0; i < 20; i++)
                    lbxLog.Items.RemoveAt(0);

            lbxLog.Items.Add(string.Format("{0}: {1}", System.DateTime.Now.ToString("dd-MM-yyyy HH:mm:ss"), log));
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            lbxLog.EndUpdate();

            Application.DoEvents();
        }
        //-----------------------------------------------------------------------------------------------------

        private void btnLimpiar_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Clear();
        }
        //-----------------------------------------------------------------------------------------------------

        private void btnAccion1_Click(object sender, EventArgs e)
        {
            pManager.doAction1();
        }
        //-----------------------------------------------------------------------------------------------------

        private void btnAccion2_Click(object sender, EventArgs e)
        {
            pManager.doAction2();
        }
        //-----------------------------------------------------------------------------------------------------

        public void logText(string txt)
        {
            lbxLog.Invoke(addText, new object[] { txt });
        }
        //-----------------------------------------------------------------------------------------------------
        //-----------------------------------------------------------------------------------------------------
    }
}
