using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using tfcSocket;

namespace tfcWeb
{
    public partial class ctlMota : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            tmrMota.Interval = 2000;
            tmrMota.Enabled = true;
        }

        public static int TextToInt32(string text)
        {
            int r = 0;

            try
            {
                r = Convert.ToInt32(text);
            }
            catch (Exception)
            {
                r = 0;
            }
            return r;
        }

        public static double TextToDouble(string text)
        {
            double r = 0.0;

            try
            {
                r = Convert.ToDouble(text);
            }
            catch (Exception)
            {
                r = 0.0;
            }
            return r;
        }

        protected void tmrMota_Tick(object sender, EventArgs e)
        {
            txtTemperatura.Text = "";
            txtHoraTemp.Text = "";
            txtLlum.Text = "";
            txtHoraLlum.Text = "";
            txtBateria.Text = "";
            txtHoraBat.Text = "";
            lblMsg.Text = "";
            lblId.Text = "101";

            txtTemperatura.UpdateAfterCallBack = true;
            txtHoraTemp.UpdateAfterCallBack = true;
            txtLlum.UpdateAfterCallBack = true;
            txtHoraLlum.UpdateAfterCallBack = true;
            txtBateria.UpdateAfterCallBack = true;
            txtHoraBat.UpdateAfterCallBack = true;
            lblMsg.UpdateAfterCallBack = true;
            lblId.UpdateAfterCallBack = true;
            btnAccio1.UpdateAfterCallBack = true;
            imgAccio1.UpdateAfterCallBack = true;
            btnAccio2.UpdateAfterCallBack = true;
            imgAccio2.UpdateAfterCallBack = true;

            string address = ConfigurationManager.AppSettings["RemoteObjectServer"].ToString();
            cTFCmanager pManager = (cTFCmanager)Activator.GetObject(typeof(cTFCmanager), address);

            if (pManager != null)
            {
                cStation st = pManager.getStation(101);
                if (st != null)
                {
                    lblMsg.Text = HttpUtility.HtmlEncode(st.LastXML);

                    cLectura lc = st.getLectura(enTFCmessageType.MSG_TEMPERATURE);
                    if (lc != null)
                    {
                        double temp = TextToDouble(lc.Dades)/100.0;
                        
                        txtTemperatura.Text = temp.ToString("#0.00") + " C";
                        txtHoraTemp.Text = lc.Moment.ToString("dd-MM-yyyy HH:mm:ss");
                    }
                    lc = st.getLectura(enTFCmessageType.MSG_LIGHT);
                    if (lc != null)
                    {
                        int nivell = TextToInt32(lc.Dades);
                        switch (nivell)
                        {
                            case 0:
                                txtLlum.Text = "Nula";
                                break;

                            case 1:
                                txtLlum.Text = "Escasa";
                                break;

                            case 2:
                                txtLlum.Text = "Normal";
                                break;

                            case 3:
                                txtLlum.Text = "Bona";
                                break;

                            case 4:
                                txtLlum.Text = "Molt alta";
                                break;
                        }
                        txtHoraLlum.Text = lc.Moment.ToString("dd-MM-yyyy HH:mm:ss");
                    }
                    lc = st.getLectura(enTFCmessageType.MSG_BATTERY);
                    if (lc != null)
                    {
                        double temp = TextToDouble(lc.Dades) / 100.0;

                        txtBateria.Text = temp.ToString("#0.00") + " V"; 
                        txtHoraBat.Text = lc.Moment.ToString("dd-MM-yyyy HH:mm:ss");
                    }
                    // Accio 1
                    System.DateTime mDO = System.DateTime.MinValue;
                    System.DateTime mDONE = System.DateTime.MinValue;

                    lc = st.getLectura(enTFCmessageType.MSG_DO_ACTION_1);
                    if (lc != null)
                        mDO = lc.Moment;

                    lc = st.getLectura(enTFCmessageType.MSG_DONE_ACTION_1);
                    if (lc != null)
                        mDONE = lc.Moment;

                    if (mDO != System.DateTime.MinValue && mDO > mDONE)
                    {
                        btnAccio1.Enabled = false;
                        imgAccio1.ImageUrl = "img/btnRed.png";
                    }
                    else
                    {
                        btnAccio1.Enabled = true;
                        imgAccio1.ImageUrl = "img/btnGreen.png";
                    }
                    // Accio 2
                    mDO = System.DateTime.MinValue;
                    mDONE = System.DateTime.MinValue;

                    lc = st.getLectura(enTFCmessageType.MSG_DO_ACTION_2);
                    if (lc != null)
                        mDO = lc.Moment;

                    lc = st.getLectura(enTFCmessageType.MSG_DONE_ACTION_2);
                    if (lc != null)
                        mDONE = lc.Moment;

                    if (mDO != System.DateTime.MinValue &&  mDO > mDONE)
                    {
                        btnAccio2.Enabled = false;
                        imgAccio2.ImageUrl = "img/btnRed.png";
                    }
                    else
                    {
                        btnAccio2.Enabled = true;
                        imgAccio2.ImageUrl = "img/btnGreen.png";
                    }
                }
            }
        }

        protected void btnAccio_Click(object sender, EventArgs e)
        {
            string address = ConfigurationManager.AppSettings["RemoteObjectServer"].ToString();
            cTFCmanager pManager = (cTFCmanager)Activator.GetObject(typeof(cTFCmanager), address);
            if (pManager == null)
                return;

            if (sender == btnAccio1)
            {
                btnAccio1.UpdateAfterCallBack = true;
                imgAccio1.UpdateAfterCallBack = true;
                btnAccio1.Enabled = false;
                imgAccio1.ImageUrl = "img/btnRed.png";
                pManager.doAction1();
            }
            else if (sender == btnAccio2)
            {
                btnAccio2.UpdateAfterCallBack = true;
                imgAccio2.UpdateAfterCallBack = true;
                btnAccio2.Enabled = false;
                imgAccio2.ImageUrl = "img/btnRed.png";
                pManager.doAction2();
            }
        }
    }
}